using System;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;

namespace TSUDPCnt
{
    internal partial class Form1 : Form
    {
        /// <summary>ݒ</summary>
        Setting setting = Setting.Load();

        /// <summary>BSCS̃`lf[^p</summary>
        struct BSCSChannelData
        {
            /// <summary>`l</summary>
            public string Name;
            /// <summary>`lf[^1</summary>
            public UInt16 Value1;
            /// <summary>`lf[^2</summary>
            public UInt16 Value2;
                        
            public override string ToString()
            {
                return Name;
            }

            /// <summary>Mp̒l</summary>
            public UInt32 Value
            {
                get
                {
                    return ((UInt32)Value1 << 16) | (UInt32)Value2;
                }
            }
        }

        /// <summary>MNX</summary>
        private UDPSender udp = new UDPSender();

        /// <summary>
        /// RXgN^
        /// </summary>
        public Form1()
        {
            InitializeComponent();

            vlcprocess = new System.Diagnostics.Process();

            //BSCS̃`lf[^init@Cf[^荞
            LoadBSCSChannelData();
            if (cbxBSCS.Items.Count > 0)
            {
                cbxBSCS.SelectedIndex = 0;
            }


            mskAddress_Validating(null , new CancelEventArgs());
            udp.Port = (int)nudPort.Value;
        }

        /// <summary>BSCS̃`lf[^init@Cf[^荞</summary>
        private void LoadBSCSChannelData()
        {
            if (System.IO.File.Exists(setting.BSCSiniPath))
            {
                using (System.IO.StreamReader sr = new System.IO.StreamReader(setting.BSCSiniPath))
                {
                    string line;
                    int equalpoint;
                    bool fsection = false;
                    while (!sr.EndOfStream)
                    {
                        line = sr.ReadLine().Trim();
                        if (line.StartsWith("["))
                        {
                            fsection = (line == "[BS110CS]");
                        }
                        else if (fsection && !line.StartsWith("#"))
                        {
                            equalpoint = line.IndexOf("=");
                            if (equalpoint >= 0)
                            {
                                BSCSChannelData bscs;
                                string[] values;
                                values = line.Substring(0 , equalpoint).Split(',');
                                if (values.Length == 2)
                                {
                                    if (UInt16.TryParse(values[0] , out bscs.Value1)
                                        && UInt16.TryParse(values[1] , System.Globalization.NumberStyles.HexNumber , null , out bscs.Value2))
                                    {
                                        bscs.Name = line.Substring(equalpoint + 1);

                                        cbxBSCS.Items.Add(bscs);
                                    }
                                }

                            }

                        }
                    }
                }
            }
        }

        /// <summary>AhX̐ݒ</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void mskAddress_Validating(object sender , CancelEventArgs e)
        {
            try
            {
                byte[] byteAddress = new byte[4];
                for (int i = 0; i < 4; i++)
                {
                    byte b;
                    if (byte.TryParse(mskAddress.Text.Substring(i * 4 , 3) , out b))
                    {
                        byteAddress[i] = b;
                    }
                    else
                    {
                        throw new ApplicationException("255ȉɂĂ");
                    }
                }
                udp.IPAddress = new IPAddress(byteAddress);
            }
            catch (System.Exception ex)
            {
                MessageBox.Show(this , ex.Message);
                e.Cancel = true;
            }
        }

        /// <summary>|[g̐ݒ</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void nudPort_Validated(object sender , EventArgs e)
        {
            udp.Port = (int)nudPort.Value;
        }

        /// <summary>TSUDP̑MOnOff؂ւ{^NbN</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnOnOff_Click(object sender , EventArgs e)
        {
            udp.SetCommand(1,chkOnOff.Checked ? 1U : 0U);
            udp.Send();
        }

        /// <summary>TSUDP̑M`l؂ւ{^NbN</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnChannel_Click(object sender , EventArgs e)
        {
            if (chkVLC.Checked && !vlcprocess.HasExited)
            {
                if (chkResetAtChannelChange.Checked)
                {
                    isResetVLC = true;
                    vlcprocess.Kill();
                }
                
            }
            if (rabWhile.Checked)
            {
                udp.SetCommand(2 , (UInt32)nudChannel.Value);
            }
            else if(rabBlack.Checked)
            {
                if (cbxBSCS.SelectedIndex >= 0)
                {
                    udp.SetCommand(2 , ((BSCSChannelData)cbxBSCS.Items[cbxBSCS.SelectedIndex]).Value);
                }
                else
                {
                    return;
                }
            }
            udp.Send();
        }


        #region "VLC֌W"
        /// <summary>`lύXƂVLCċN邩</summary>
        private bool isResetVLC = false;
        /// <summary>NVLC̃vZX</summary>
        System.Diagnostics.Process vlcprocess;

        /// <summary>VLC̋N؂ւ</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chkVLC_CheckedChanged(object sender , EventArgs e)
        {
            try
            {
                if (chkVLC.Checked)
                {
                    StartVLC();
                }
                else
                {
                    if (!vlcprocess.HasExited)
                    {
                        vlcprocess.Kill();
                    }
                }
            }
            catch 
            {
                vlcprocess.Close();
            }
        }

        /// <summary>VLCIƂɌĂяo</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void VLCExited(System.Object sender , EventArgs e)
        {
            if (this.InvokeRequired)
            {   //ʃXbh炭邩
                this.Invoke(new EventHandler(VLCExited),sender,e);
            }
            else
            {
                if (isResetVLC)
                {
                    StartVLC();
                }
                else
                {
                    chkVLC.Checked = false;
                }
            }
        }

        /// <summary>VLCN</summary>
        private void StartVLC()
        {
            string arg = setting.VLCOptions + " udp:@:" + nudVLCPort.Value.ToString();
            vlcprocess = System.Diagnostics.Process.Start(setting.VLCPath , arg);
            vlcprocess.Exited += new EventHandler(VLCExited);
            vlcprocess.EnableRaisingEvents = true;
            isResetVLC = false;
        }
        #endregion



    }


    internal class UDPSender : IDisposable 
    {
        private System.Net.Sockets.UdpClient udp
            = new System.Net.Sockets.UdpClient();
        System.Net.IPEndPoint endpoint
            = new System.Net.IPEndPoint(System.Net.IPAddress.None , 0);
        byte[] buff = new byte[19];

        public IPAddress IPAddress
        {
            get
            {
                return endpoint.Address;
            }
            set
            {
                endpoint.Address = value;
            }
        }

        public int Port
        {
            get
            {
                return endpoint.Port;
            }
            set
            {
                endpoint.Port = value;
            }
        }

        public UDPSender()
        {
            byte[] btemp;
            btemp = System.Text.Encoding.ASCII.GetBytes("TSUDP");
            Array.Copy(btemp , buff , 5);
        }

        /// <summary>MR}h̃f[^Zbg</summary>
        /// <param name="number">R}hԍ</param>
        /// <param name="value">R}h̒l</param>
        public void SetCommand(UInt32 number , UInt32 value)
        {
            byte[] btemp;
            btemp = System.BitConverter.GetBytes(number);
            Array.Copy(btemp , 0 , buff , 9 , 4);
            btemp = System.BitConverter.GetBytes(value);
            Array.Copy(btemp , 0 , buff , 13 , 4);

            //lbg[NɗȂ{̓rbOGfBAɂׂ
            //łʓ|炻̂܂
        }

        /// <summary>R}hM</summary>
        public void Send()
        {
            udp.Send(buff , buff.Length , endpoint);
        }

        #region IDisposable o

        public void Dispose()
        {
            udp.Close();
        }

        #endregion
    }

    /// <summary>ݒpNX</summary>
    public class Setting
    {
        private string _VLCPath;

        /// <summary>VLCւ̃pX</summary>
        public string VLCPath
        {
            get { return _VLCPath; }
            set { _VLCPath = System.Environment.ExpandEnvironmentVariables(value);}
        }

        private string _BSCSiniPath;
        /// <summary>BSCS̃`lf[^ւ̃pX</summary>
        public string BSCSiniPath
        {
            get { return _BSCSiniPath; }
            set { _BSCSiniPath = System.Environment.ExpandEnvironmentVariables(value);}
        }

        /// <summary>VLCǉIvV</summary>
        public string VLCOptions;

        /// <summary>ݒǂݍݗpt@Ng</summary>
        /// <returns></returns>
        /// <exception cref="System.IO.Exception">ݒt@C</exception>
        public static Setting Load()
        {
            System.Xml.Serialization.XmlSerializer seri
                = new System.Xml.Serialization.XmlSerializer(typeof(Setting));
            using (System.IO.StreamReader sr = new System.IO.StreamReader("TSUDPCnt.xml"))
            {
                return  (Setting)seri.Deserialize(sr);
            }
        }


    }
}